// Copyright (c)2002-2003 Eric Carlson
// This source is licensed under the BSD license.
// Please see the LICENSE.txt file included with the distribution for more information.

#import "TestPatternView.h"


@implementation TestPatternView

/*
- (id)initWithFrame:(NSRect)frame {
    self = [super initWithFrame:frame];
    if (self) {
        // Initialization code here.
    }
    return self;
}
*/

- (void)drawRect:(NSRect)rect {
    NSGraphicsContext *nsgc = [NSGraphicsContext currentContext];
    CGContextRef gc = [nsgc graphicsPort];

    NSEraseRect(rect);

    //draw stuff here
    myDraw(gc, (CGRect *)&rect);
}

- (void)forceUpdate:(id)sender
{
    [self setNeedsDisplay:YES];
}

@end

void myDraw(CGContextRef context, CGRect* contextRect)
{
    int w, h, i;

    w = contextRect->size.width;
    h = contextRect->size.height;

    CGContextSetShouldAntialias(context, 0); //turn antialiasing OFF
    CGContextSetLineWidth(context, 1.0); //line width

    //black background
    CGContextSetRGBStrokeColor(context, 0.0,0.0,0.0,1.0);
    CGContextSetRGBFillColor(context, 0.0,0.0,0.0,1.0);
    CGContextFillRect(context, CGRectMake(0,0,w,h));

    //change to white for all future drawing
    CGContextSetRGBStrokeColor(context, 1.0,1.0,1.0,1.0);
    CGContextSetRGBFillColor(context, 1.0,1.0,1.0,1.0);

    //0.5 is the "center" of the pixel
    CGContextStrokeRect(context, CGRectMake(0.5,0.5,w-0.5,h-0.5));
    
    CGContextBeginPath(context);
    CGContextAddArc(context, w/2, h/2, (h/2), 0, 2*M_PI, 0);
    CGContextClosePath(context);
    CGContextStrokePath(context);

    CGContextBeginPath(context);
    for(i=0; i<20; i++) {
        CGContextMoveToPoint(context, ((int)(i*(w/20.0)))+0.5, h-0.5);
        CGContextAddLineToPoint(context, ((int)(i*(w/20.0)))+0.5, 0.5);
    }
    CGContextClosePath(context);
    CGContextStrokePath(context);

    CGContextBeginPath(context);
    for(i=0; i<16; i++) {
        CGContextMoveToPoint(context, 0.5, ((int)(i*(h/16.0)))+0.5);
        CGContextAddLineToPoint(context, w-0.5, ((int)(i*(h/16.0)))+0.5);
    }
    CGContextClosePath(context);
    CGContextStrokePath(context);
    
    
}
