// Copyright (c)2002-2003 Eric Carlson
// This source is licensed under the BSD license.
// Please see the LICENSE.txt file included with the distribution for more information.

// Based on information from USB Monitor Control Class Specification, Revision 1.0 (January 5, 1998).
// Available from http://www.usb.org/developers/data/devclass/usbmon10.pdf

#ifndef _USBMonitorControlClassSpec_h_
#define _USBMonitorControlClassSpec_h_

/* //no longer used since we don't specifically identify monitors anymore
// Identifiers for Mitsubishi Diamond Plus 200
long kMitsuDiamondPlus200_ProdID = 256;
long kMitsuDiamondPlus200_VendID = 1106;

// Identifiers for Mitsubishi Diamond Pro 2040u (version 1)
long kMitsuDiamondPro2040u_1_ProdID = 21931;
long kMitsuDiamondPro2040u_1_VendID = 1033;

// Identifiers for Mitsubishi Diamond Pro 2040u (version 2)
long kMitsuDiamondPro2040u_2_ProdID = 131;
long kMitsuDiamondPro2040u_2_VendID = 1106;

// Identifiers for Mitsubishi Diamond Pro 2045u
long kMitsuDiamondPro2045u_ProdID = 257;
long kMitsuDiamondPro2045u_VendID = 1106;

// Identifiers for Mitsubishi Diamond Pro 900u
long kMitsuDiamondPro900u_ProdID = 81;
long kMitsuDiamondPro900u_VendID = 1106;

// Identifiers for NEC Multisync FP950
long kNECMultisyncFP950_ProdID = 39;
long kNECMultisyncPF950_VendID = 1033;
*/
 
//usage pages
enum {
    kHIDPage_Monitor 	= 0x80,
    kHIDPage_Enum	= 0x81,
    kHIDPage_VESA	= 0x82
};

//usages
enum {
    kHIDMonitorUsagePage_Reserved	= 0x00,
    kHIDMonitorUsagePage_Control 	= 0x01,
    kHIDMonitorUsagePage_EDID    	= 0x02,
    kHIDMonitorUsagePage_VDIF    	= 0x03,
    kHIDMonitorUsagePage_VESA    	= 0x04
};

//element usages for page kHIDPage_VESA
enum {
    kHIDVESAUsagePage_Brightness	= 0x10, 				//900U
    kHIDVESAUsagePage_Contrast		= 0x12, 				//900U
    
    kHIDVESAUsagePage_RedGain		= 0x16,
    kHIDVESAUsagePage_GreenGain		= 0x18,
    kHIDVESAUsagePage_BlueGain		= 0x1A,
    
    kHIDVESAUsagePage_Focus		= 0x1C,
    
    kHIDVESAUsagePage_HorizPosition	= 0x20, 				//900U
    kHIDVESAUsagePage_HorizSize		= 0x22, 				//900U
    kHIDVESAUsagePage_HorizPin		= 0x24,					//900U
    kHIDVESAUsagePage_HorizPinBal	= 0x26,					//900U
    kHIDVESAUsagePage_HorizMisConv	= 0x28,					//900U
    kHIDVESAUsagePage_HorizLin		= 0x2A,
    kHIDVESAUsagePage_HorizLinBal	= 0x2C,
    
    kHIDVESAUsagePage_VertPosition	= 0x30, 				//900U
    kHIDVESAUsagePage_VertSize		= 0x32,					//900U
    kHIDVESAUsagePage_VertPin		= 0x34,
    kHIDVESAUsagePage_VertPinBal	= 0x36,
    kHIDVESAUsagePage_VertMisConv	= 0x38,					//900U
    kHIDVESAUsagePage_VertLin		= 0x3A,
    kHIDVESAUsagePage_VertLinBal	= 0x3C,
    
    kHIDVESAUsagePage_KeyBalance	= 0x40, //Parallelogram Distortion	//900U
    kHIDVESAUsagePage_Key		= 0x42, //Trapezoidal Distortion	//900U
    kHIDVESAUsagePage_Tilt		= 0x44, //aka Rotation			//900U
    kHIDVESAUsagePage_TCDistControl 	= 0x46, //TC = Top Corner		//900U
    kHIDVESAUsagePage_TCDistBalance 	= 0x48, 				//900U
    kHIDVESAUsagePage_BCDistControl 	= 0x4A, //BC = Bottom Corner		//900U
    kHIDVESAUsagePage_BCDistBalance 	= 0x4C,
    
    kHIDVESAUsagePage_HorizMoire	= 0x56,
    kHIDVESAUsagePage_VertMoire		= 0x58,
    
    kHIDVESAUsagePage_RedLuminance 	= 0x6C,
    kHIDVESAUsagePage_GreenLuminance 	= 0x6E,
    kHIDVESAUsagePage_BlueLuminance	= 0x70,
    
    //Non-contiguous Read/Write Controls (ENUMs)
    kHIDVESAUsagePage_InputLevel	= 0x5E,
    kHIDVESAUsagePage_InputSource	= 0x60,
    kHIDVESAUsagePage_OSD		= 0xCA, //On Screen Display
    kHIDVESAUsagePage_StereoMode	= 0xD4,
    
    //Non-contiguous Read-Only Controls (ENUMs)
    kHIDVESAUsagePage_AutoSize		= 0xA2,
    kHIDVESAUsagePage_PolarityHorizSync	= 0xA4,
    kHIDVESAUsagePage_PolarityVertSync	= 0xA6,
    kHIDVESAUsagePage_SyncType		= 0xA8,
    kHIDVESAUsagePage_ScreenOrient	= 0xAA,
    kHIDVESAUsagePage_HorizFreq		= 0xAC,
    kHIDVESAUsagePage_VertFreq		= 0xAE,
    
    //Non-contiguous Write-only Controls
    kHIDVESAUsagePage_Degauss		= 0x01, //non-zero means start degauss	//900U
    kHIDVESAUsagePage_Settings		= 0xB0  //Save/Restore settings (ENUM)
};

#endif